/**************************************************************
	4 channels analog convert to serial port out (software serial) 
	 for PIC12F675
 **************************************************************
	author air_variable
	http://www.ne.jp/asahi/air/variable/
	version 2.00
	Tools:
	MPLAB v8.15a
	Hitech PIC C pro9.60pl4 lite mode build 3206 or higher
---------------------------------------------------------------
Date	:Time	Version	Build	Note
20081106:0750	2.00	---		Correspond Hitech PIC C pro9.60pl4 build 2729 or higher
20081111:2350	2.01	---		Remove "OSCCAL = _READ_OSCCAL_DATA()" and minor fix

---------------------------------------------------------------
	Pin assignment
	1:Vcc:3to5V
	2:GP5:O:-TX
	 (RS232C direct logic) must current limit circuit (ex. 330ohm)
	3:GP4/AN3:Analog input
	4:GP3/MCLR:I:-RX
	 (RS232C direct logic) Must connect weak current limit circuit(ex.100koht and diode protection)
	5:GP2/AN2:Analog input
	6:GP1/AN1:Analog input
	7:GP0/AN0:Analog input
	8:Vss:GND

**************************************************************/

#include <htc.h>
#include <conio.h>

#define newline sci_puts("\r\n") //sACRR[h
#define MHz 000000
#define _XTAL_FREQ 4MHz


__CONFIG(0x3FC4);


void sci_puts(const unsigned char * s){
	while(*s){
		putch(*s++);
	}
}
void adinit(void){
	ADON=1;	//ADRo[^dI
	ADFM=1;	//E
	VCFG=0;	//Vref =Vdd
	CHS1=0;	//
	CHS0=0;	//
}

unsigned int adconv(unsigned char adselect){
	unsigned int temp;
	ADCON0 = (ADCON0 & 0b11110011) |(( adselect <<2) & 0b00001100);//AD`lZbg 
	__delay_us(20);//20us wait
	GODONE=1;	//ϊX^[g
	while(GODONE);//ADϊ
	temp =ADRESH;
	temp =( temp<<8 )| ADRESL;
	return temp;
}

void adc_valueout(unsigned char ch){
	unsigned int temp=adconv(ch);
	putch(ch+0x30);//ascii code convert `l\
	sci_puts(" ch: ");
	putch(((temp /1000)%10)+0x30);//1000̈ʂvZăAXL[R[h0x30𑫂
	putch(((temp / 100)%10)+0x30);//100̈ʂvZăAXL[R[h0x30𑫂
	putch(((temp /  10)%10)+0x30);//10̈ʂvZăAXL[R[h0x30𑫂
	putch(((temp      )%10)+0x30);//1̈ʂvZăAXL[R[h0x30𑫂
	return;
}
	

void adc_allvalueout(void){
	unsigned char i=4;//use channel
	while(i--){
		adc_valueout(3-i);
		sci_puts("  ");//Delimit code ؂蕶
	}
	return;
}

//------------------main
void main(void){
	unsigned char temp;
//	OSCCAL = _READ_OSCCAL_DATA(); //osccal setting(legacy version)
// Register
//	Port initalize
	CMCON 	= 	0x07;			//12F675 ,629 require
    ANSEL 	= 	0b01111111;		//12F675 require AD osc =rc all use analog in
//		  	  	  76543210
	TRISIO	= 	0b11011111;		//gpAiO|[g͓͂ɂ邱
	GPIO	=	0b00100000;		//Port Initalize

	putch(' ');	//ŏ̒ʐM̃S~
	adinit();
	__delay_ms(100);//0.1bEGCg
	sci_puts("\r\nAD converter test\r\n");//I[vjObZ[W
	while(1){
		temp=getch();
		switch (temp){
			case 'a':	//Display all ADC Data
				adc_allvalueout();
				newline;
				break;
			case '0':	//Display all ADC Data	
				adc_valueout(0);
				newline;
				break;
			case '1':	//Display all ADC Data	
				adc_valueout(1);
				newline;
				break;
			case '2':	//Display all ADC Data	
				adc_valueout(2);
				newline;
				break;
			case '3':	//Display all ADC Data	
				adc_valueout(3);
				newline;
				break;
			case 'c':	//Display all clear	
				putch(12);
				break;
			case 'l':	//All ch loop Display(endless)	

				while(1){
					adc_allvalueout();
					sci_puts("\r");//ɕ\ׁA\n͕tĂȂ
					}
					
				break;
			default:	//	
				putch( temp );
		}		
	}
}
		
